# -----------------------------------------------------------------------------
# $Id: ChannelInfo.pm,v 1.11 2003/07/19 05:15:57 admin Exp $
# -----------------------------------------------------------------------------
# ͥݻ
# -----------------------------------------------------------------------------
package ChannelInfo;
use strict;
use warnings;
use Carp;
use PersonInChannel;
use Multicast;
our $AUTOLOAD;

sub new {
    # name˻̾ޤդʤ褦ա#channel@ircnetNG
    my ($class,$name,$network_name) = @_;    
    my $obj = {
	name => $name,
	network_name => $network_name,
	topic => '',
	names => {}, # nick => PersonInChannel
	switches => {}, # asʤɤΥͥ⡼ɡasǡͤϾ1
	parameters => {}, # lkʤɤΥͥ⡼ɡ
	banlist => [], # +bꥹȡΤʤж
	exceptionlist => [], # +eꥹȡΤʤж
	invitelist => [], # +IꥹȡΤʤж
	remarks => {}, # TiarraŪ˻Ѥ͡
    };
    
    unless (defined $name) {
	croak "ChannelInfo->new requires name parameter.\n";
    }
    
    bless $obj,$class;
}

sub equals {
    # ͥ̾ȥСƱʤ鿿
    my ($this,$ch) = @_;
    defined $ch && $this->name eq $ch->name &&
	$this->network_name eq $ch->network_name;
}

sub fullname {
    # С̾դ֤
    my $this = shift;
    scalar Multicast::attach($this->name,$this->network_name);
}

my $types = {
    topic => 'scalar',
    names => 'hash',
    switches => 'hash',
    parameters => 'hash',
    banlist => 'array',
    exceptionlist => 'array',
    invitelist => 'array',
    remarks => 'hash',
};
sub remarks;
*remark = \&remarks; # remarkremarksΥꥢ
sub AUTOLOAD {
    my ($this,@args) = @_;
    (my $key = $AUTOLOAD) =~ s/^.+?:://g;
    
    if ($key eq 'DESTROY') {
	return;
    }

    if ($key eq 'name' || $key eq 'network_name') {
	return $this->{$key};
    }
    
    my $type = $types->{$key};
    if (!defined($type)) {
	croak "ChannelInfo doesn't have the parameter $key\n";
    }
    
    if ($type eq 'scalar') {
	# $info->topic;
	# $info->topic('NEW-TOPIC');
	if (defined $args[0]) {
	    $this->{$key} = $args[0];
	}
	return $this->{$key};
    }
    elsif ($type eq 'hash') {
	# $info->names;
	# $info->names('saitama');
	# $info->names('saitama',$person);
	# $info->names('saitama',undef,'delete');
	# $info->names(undef,undef,'clear');
	# $info->names(undef,undef,'size');
	# $info->names(undef,undef,'keys');
	# $info->names(undef,undef,'values');
	if (!defined $args[0] && !defined $args[2]) {
	    # HASH*֤
	    return $this->{$key};
	}
	
	if (defined $args[1]) {
	    $this->{$key}->{$args[0]} = $args[1];
	}
	if (defined $args[2]) {
	    if ($args[2] eq 'delete') {
		delete $this->{$key}->{$args[0]};
	    }
	    elsif ($args[2] eq 'clear') {
		$this->{$key} = {};
	    }
	    elsif ($args[2] eq 'size') {
		return scalar(keys %{$this->{$key}});
	    }
	    elsif ($args[2] eq 'keys') {
		return keys %{$this->{$key}};
	    }
	    elsif ($args[2] eq 'values') {
		return values %{$this->{$key}};
	    }
	    else {
		croak '[array]->([key],[value],'.$args[2].") is invalid\n";
	    }
	}
	return $this->{$key}->{$args[0]};
    }
    elsif ($type eq 'array') {
	# $info->banlist;
	# $info->banlist('set','a!*@*','b!*@*','c!*@*');
	# $info->banlist('add','*!*@*.hoge.net');
	# $info->banlist('delete','*!*@*.hoge.net');
	my $array = $this->{$key};
	if (@args == 0) {
	    # ARRAY*֤
	    return $array;
	}

	if ($args[0] eq 'set') {
	    @$array = @args[1 .. $#args];
	}
	elsif ($args[0] eq 'add') {
	    croak "'add' requires a value to add\n" unless defined $args[1];
	    push @$array,$args[1];
	}
	elsif ($args[0] eq 'delete') {
	    croak "'delete' requires a value to remove\n" unless defined $args[1];
	    for (my $i = 0; $i < @$array; $i++) {
		if ($array->[$i] eq $args[1]) {
		    splice @$array,$i,1;
		    $i--;
		}
	    }
	}
	else {
	    croak "invalid command '".$args[0]."'\n";
	}
	return $this;
    }
}

1;
